// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    //private static final Color bgcolor = new Color(236,236,236);
    private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;

    //Mod1State state;
    public Button bupdate;
  
    public Instructions(){
	super();
        //this.state = state;
	setLayout(null);
	setBackground(bgcolor);
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(240,240,255));
	add(bupdate);
        //int buttonx = 410;
        //int buttony = 440;
        int buttonx = 500;
        int buttony = 455;
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        
        int startx = 20; int starty = 90;
        g.drawString("Instructions", startx,40);
        
        //g.setFont(state.ttfFont.deriveFont(14f));
        //g.setFont(new Font("SanSerif",Font.PLAIN,14));
        //g.drawString("This module can accomodate linearly polarized plane "+
        //            "waves in both lossy and lossless media.",15,50);
        
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int nextX;
        //String s = "This module simulates how a short dipole radiates an EM "+
        //    " wave into its ";
        //int nextX = STR.displayString(s,g,200,15);
        //s = "  surrounding space.  The dipole is oriented along the z-axis.";
        //nextX = STR.displayString(s,g,200,35);

        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        //g.drawString("Input", 15,50);
        g.drawString("Input", startx,starty);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int deltaY = 25;
        //INPUT
        String s = "\u2022 Plot Range: The spatial dimension (in units of \u03bb)"+
            " of the display plane";
        nextX = STR.displayString(s,g,startx,starty+2*deltaY);
        s = "\u2022 Choice of Horizontal (x-y) or Vertical Plane";
        nextX = STR.displayString(s,g,startx,starty+3*deltaY);
        s = "\u2022 Choice of E"+STR.SUB+"\u03b8"+STR.ENDSUB+" (exact "+
            "solution) or E"+STR.SUB+"\u03b8FF"+STR.ENDSUB+
            " (far-field approximation)";
        nextX = STR.displayString(s,g,startx,starty+4*deltaY);
       //OUTPUT
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        int newY = starty+7*deltaY;
        g.drawString("Displayed Information", startx,newY);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        newY += 40;
        s = "\u2022 2-D patterns of E\u03b8"+STR.SUB+"\u03b8"+STR.ENDSUB+
            " and H"+STR.SUB+"\u03c6"+STR.ENDSUB+", in the Horizontal"+
            " and Vertical planes";
        nextX = STR.displayString(s,g,startx,newY);
        s = "\u2022 Dynamic simulation of how E"+STR.SUB+"\u03b8"+STR.ENDSUB+
            ", H"+STR.SUB+"\u03c6"+STR.ENDSUB+", and the current I(t), "+
            "vary with time";
        nextX = STR.displayString(s,g,startx,newY+deltaY);
        drawCopyRight(g);

        //MaestroG.useBiggerFont = saveOldFlag;

    }


    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 75;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+15,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        String s = "Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
            " platform:  www.amanogawa.com";
        int nextX = STR.displayString(s,g,startingX+15,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("All Rights Reserved",startingX+15,startingY+3*deltaY);
        g.drawLine(startingX,startingY+5,
                   startingX+15+lineLength+10,startingY+5);
        g.drawLine(startingX+15+lineLength+10,startingY+5,
                   startingX+15+lineLength+10,startingY+4*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

